export class ereaderComponent {
    constructor() {
        this.ereaderbasepath = window.location.origin + "/ereader-component/ereader";
        // Globals
        this._ereader_layout = {
            "fixed_epub": "Fixed",
            "page_faithful_epub": "PageFaithful",
            "reflowable_epub": "Reflowable",
            "html_format": "Html",
            "cdn_png": "png",
            "local_png": "png"
        };
        this._resourceList = {
            icons: [],
            styles: [
                'https://fonts.googleapis.com/icon?family=Material+Icons'
            ],
            scripts: [
                this.ereaderbasepath + '/runtime.js',
                this.ereaderbasepath + '/polyfills.js',
                this.ereaderbasepath + '/styles.js',
                this.ereaderbasepath + '/scripts.js',
                this.ereaderbasepath + '/vendor.js',
                this.ereaderbasepath + '/main.js'
            ],
        };
    }
    // Component LifeCycle Methods
    componentWillLoad() {
        this.bookDetailsToEreader = {
            "bookPath": this.bookpath,
            "bookId": this.bookid,
            "slug": this.slug,
            "layout": this._ereader_layout[this.layout],
            "bookTitle": this.booktitle,
            "eReaderBase": this.ereaderbasepath,
        };
        this.renderEreader();
    }
    componentDidLoad() {
    }
    // Lifecycle Method Ends
    // Render EReader Ui 
    renderEreader() {
        // Insert Web Component 
        let baseNode = document.createElement('base');
        baseNode.href = "/";
        document.head.appendChild(baseNode);
        for (var key in this._resourceList) {
            if (key == 'icons') {
                //for(var script= 0 ;script <)
            }
            else if (key == 'styles') {
                for (var style = 0; style < this._resourceList[key].length; style++) {
                    var linkNode = document.createElement('link');
                    linkNode.href = this._resourceList[key][style];
                    linkNode.rel = "stylesheet";
                    linkNode.type = "text/css";
                    document.head.appendChild(linkNode);
                }
            }
            else if (key == 'scripts') {
                for (var script = 0; script < this._resourceList[key].length; script++) {
                    var scriptNode = document.createElement('script');
                    scriptNode.src = this._resourceList[key][script];
                    scriptNode.type = "text/javascript";
                    document.body.appendChild(scriptNode);
                }
            }
        }
    }
    render() {
        return (h("app-root", { bookDetails: JSON.stringify(this.bookDetailsToEreader) }, "Loading please wait..."));
    }
    static get is() { return "e-reader"; }
    static get properties() { return {
        "bookid": {
            "type": String,
            "attr": "bookid"
        },
        "bookpath": {
            "type": String,
            "attr": "bookpath"
        },
        "booktitle": {
            "type": String,
            "attr": "booktitle"
        },
        "config": {
            "type": "Any",
            "attr": "config"
        },
        "layout": {
            "type": String,
            "attr": "layout"
        },
        "slug": {
            "type": String,
            "attr": "slug"
        }
    }; }
    static get events() { return [{
            "name": "onBookmarkSave",
            "method": "onBookmarkSave",
            "bubbles": true,
            "cancelable": true,
            "composed": true
        }, {
            "name": "onBookmarkDelete",
            "method": "onBookmarkDelete",
            "bubbles": true,
            "cancelable": true,
            "composed": true
        }, {
            "name": "onSearchData",
            "method": "onSearchData",
            "bubbles": true,
            "cancelable": true,
            "composed": true
        }, {
            "name": "onCloseReader",
            "method": "onCloseReader",
            "bubbles": true,
            "cancelable": true,
            "composed": true
        }, {
            "name": "loadBookmarkData",
            "method": "loadBookmarkData",
            "bubbles": true,
            "cancelable": true,
            "composed": true
        }, {
            "name": "loadThumbnailData",
            "method": "loadThumbnailData",
            "bubbles": true,
            "cancelable": true,
            "composed": true
        }]; }
    static get style() { return "/**style-placeholder:e-reader:**/"; }
}
