export class ereaderEventEmitter {
    constructor() {
        this.events = {};
    }
    subscribe(evName, fn) {
        if (!this.events[evName]) {
            this.events[evName] = [];
        }
        this.events[evName].push(fn);
        return () => {
            this.events[evName] = this.events[evName].filter(eventFn => fn !== eventFn);
        };
    }
    emit(evName, data) {
        // Calling event and send Data
        const event = this.events[evName];
        if (event) {
            event.forEach(fn => {
                fn.emit(data);
            });
        }
    }
}
